import React from 'react';
import PropTypes from 'prop-types';
import { graphql } from 'react-apollo';
import { currentUserQuery, getUserPermissionsArray } from '../../../scenes/Auth';
import NavigationList from './NavigationList';

var Navigation = function Navigation(_ref) {
  var data = _ref.data,
      items = _ref.items;

  var userPermissions = getUserPermissionsArray(data.currentUser);

  return React.createElement(
    'nav',
    { className: 'department-navigation' },
    React.createElement(NavigationList, { items: items, userPermissions: userPermissions })
  );
};

Navigation.propTypes = {
  data: PropTypes.object.isRequired,
  items: PropTypes.array.isRequired
};

export default graphql(currentUserQuery, {
  options: { fetchPolicy: 'cache-only' }
})(Navigation);