import React from 'react';
import PropTypes from 'prop-types';
import NavigationListItem from './NavigationListItem';
import { permissionExists } from '../../../scenes/Auth';

var NavigationList = function NavigationList(_ref) {
  var items = _ref.items,
      userPermissions = _ref.userPermissions;
  return React.createElement(
    'ul',
    { className: 'navigation-list' },
    items.map(function (item) {
      return permissionExists(userPermissions, item.permission) ? React.createElement(NavigationListItem, { key: item.path, path: '/' + item.path, text: item.title }) : null;
    })
  );
};

NavigationList.propTypes = {
  items: PropTypes.array.isRequired,
  userPermissions: PropTypes.array.isRequired
};

export default NavigationList;