import cookie from 'js-cookie';

export function getUserPermissionsArray(user) {
  return user.permissions.map(function (permission) {
    return permission.title;
  });
}

export function permissionExists(permissionsArray, permission) {
  return permissionsArray.includes('admin.all') || permissionsArray.includes(permission);
}

export function userHasPermission(user, permission) {
  if (!user || !user.permissions) {
    return false;
  }

  var permissions = getUserPermissionsArray(user);

  return permissionExists(permissions, permission);
}

export var authBatchMiddleware = {
  applyBatchMiddleware: function applyBatchMiddleware(req, next) {
    var token = cookie.get('token');

    if (!req.options.headers) {
      req.options.headers = {};
    }

    req.options.headers.authorization = token ? 'Bearer ' + token : null;

    next();
  }
};