var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { graphql } from 'react-apollo';
import { Redirect } from 'react-router-dom';
import Helmet from 'react-helmet';
import cookie from 'js-cookie';
import { currentUserQuery } from '../../Auth';
import { Navigation } from '../../../components/Navigation';
import { showDangerNotification } from '../../../components/Notifications';
import { Modals } from '../../../components/Modals';
import { Loading } from '../../../components/Loading';

var Layout = function (_Component) {
  _inherits(Layout, _Component);

  function Layout() {
    _classCallCheck(this, Layout);

    return _possibleConstructorReturn(this, (Layout.__proto__ || Object.getPrototypeOf(Layout)).apply(this, arguments));
  }

  _createClass(Layout, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      if (props.data.error) {
        var errorMessage = props.data.error.graphQLErrors.length ? props.data.error.graphQLErrors[0].message : props.data.error.message;

        showDangerNotification(errorMessage);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          _props$data = _props.data,
          loading = _props$data.loading,
          error = _props$data.error,
          icons = _props.icons,
          location = _props.location,
          menuItems = _props.menuItems,
          title = _props.title;


      if (loading) {
        return React.createElement(Loading, null);
      }

      if (!loading && error) {
        return React.createElement(Redirect, { to: { pathname: '/login', state: { from: location } } });
      }

      return React.createElement(
        'section',
        { className: 'department-contents' },
        React.createElement(
          Helmet,
          null,
          React.createElement(
            'title',
            null,
            title
          )
        ),
        icons && icons(),
        React.createElement(Navigation, { items: menuItems }),
        React.createElement(
          'main',
          { className: 'department-main' },
          children
        ),
        React.createElement(Modals, null)
      );
    }
  }]);

  return Layout;
}(Component);

Layout.propTypes = {
  children: PropTypes.node.isRequired,
  data: PropTypes.object.isRequired,
  icons: PropTypes.func,
  location: PropTypes.object.isRequired,
  menuItems: PropTypes.array.isRequired,
  title: PropTypes.string
};

Layout.defaultProps = {
  title: 'Department'
};

export default graphql(currentUserQuery, {
  options: function options(props) {
    return {
      variables: {
        token: cookie.get('token') || ''
      },
      fetchPolicy: 'network-only',
      pollInterval: props.updateUserInterval || 300000
    };
  }
})(Layout);