'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactApollo = require('react-apollo');

var _Auth = require('../../../scenes/Auth');

var _NavigationList = require('./NavigationList');

var _NavigationList2 = _interopRequireDefault(_NavigationList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Navigation = function Navigation(_ref) {
  var data = _ref.data,
      items = _ref.items;

  var userPermissions = (0, _Auth.getUserPermissionsArray)(data.currentUser);

  return _react2.default.createElement(
    'nav',
    { className: 'department-navigation' },
    _react2.default.createElement(_NavigationList2.default, { items: items, userPermissions: userPermissions })
  );
};

Navigation.propTypes = {
  data: _propTypes2.default.object.isRequired,
  items: _propTypes2.default.array.isRequired
};

exports.default = (0, _reactApollo.graphql)(_Auth.currentUserQuery, {
  options: { fetchPolicy: 'cache-only' }
})(Navigation);