'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _NavigationListItem = require('./NavigationListItem');

var _NavigationListItem2 = _interopRequireDefault(_NavigationListItem);

var _Auth = require('../../../scenes/Auth');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NavigationList = function NavigationList(_ref) {
  var items = _ref.items,
      userPermissions = _ref.userPermissions;
  return _react2.default.createElement(
    'ul',
    { className: 'navigation-list' },
    items.map(function (item) {
      return (0, _Auth.permissionExists)(userPermissions, item.permission) ? _react2.default.createElement(_NavigationListItem2.default, { key: item.path, path: '/' + item.path, text: item.title }) : null;
    })
  );
};

NavigationList.propTypes = {
  items: _propTypes2.default.array.isRequired,
  userPermissions: _propTypes2.default.array.isRequired
};

exports.default = NavigationList;