'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.store = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.configureStore = configureStore;

var _redux = require('redux');

var _reduxForm = require('redux-form');

var _developmentOnly = require('redux-devtools-extension/developmentOnly');

var _Notifications = require('../../components/Notifications');

var _Modals = require('../../components/Modals');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

// eslint-disable-next-line import/no-mutable-exports
var store = exports.store = void 0;

function configureStore(apolloClient) {
  var reducers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var initialState = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var middleware = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

  exports.store = store = (0, _redux.createStore)((0, _redux.combineReducers)(_extends({
    apollo: apolloClient.reducer(),
    form: _reduxForm.reducer,
    notifications: _Notifications.notificationsReducer,
    modals: _Modals.modalsReducer
  }, reducers)), initialState, _redux.compose.apply(undefined, [(0, _redux.applyMiddleware)(apolloClient.middleware())].concat(_toConsumableArray(middleware), [(0, _developmentOnly.devToolsEnhancer)()])));

  return store;
}