'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactApollo = require('react-apollo');

var _Loading = require('../../../components/Loading');

var _api = require('../api');

var _utilities = require('../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function securedPage(options) {
  return function (WrappedComponent) {
    var SecuredPage = function SecuredPage(_ref) {
      var data = _ref.data,
          restProps = _objectWithoutProperties(_ref, ['data']);

      var loading = data.loading,
          error = data.error,
          currentUser = data.currentUser;


      if (loading) {
        return _react2.default.createElement(_Loading.Loading, null);
      }

      if (!loading && error) {
        return _react2.default.createElement(
          'p',
          null,
          'Request error'
        );
      }

      if (!loading && !(0, _utilities.userHasPermission)(currentUser, options.permission)) {
        return _react2.default.createElement(
          'p',
          null,
          'Forbidden'
        );
      }

      return _react2.default.createElement(WrappedComponent, restProps);
    };

    SecuredPage.propTypes = {
      data: _propTypes2.default.object.isRequired
    };

    return (0, _reactApollo.graphql)(_api.currentUserQuery, {
      options: { fetchPolicy: 'cache-only' }
    })(SecuredPage);
  };
}

exports.default = securedPage;