'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactApollo = require('react-apollo');

var _reactRouterDom = require('react-router-dom');

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

var _Auth = require('../../Auth');

var _Navigation = require('../../../components/Navigation');

var _Notifications = require('../../../components/Notifications');

var _Modals = require('../../../components/Modals');

var _Loading = require('../../../components/Loading');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Layout = function (_Component) {
  _inherits(Layout, _Component);

  function Layout() {
    _classCallCheck(this, Layout);

    return _possibleConstructorReturn(this, (Layout.__proto__ || Object.getPrototypeOf(Layout)).apply(this, arguments));
  }

  _createClass(Layout, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      if (props.data.error) {
        var errorMessage = props.data.error.graphQLErrors.length ? props.data.error.graphQLErrors[0].message : props.data.error.message;

        (0, _Notifications.showDangerNotification)(errorMessage);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          _props$data = _props.data,
          loading = _props$data.loading,
          error = _props$data.error,
          icons = _props.icons,
          location = _props.location,
          menuItems = _props.menuItems,
          title = _props.title;


      if (loading) {
        return _react2.default.createElement(_Loading.Loading, null);
      }

      if (!loading && error) {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: { pathname: '/login', state: { from: location } } });
      }

      return _react2.default.createElement(
        'section',
        { className: 'department-contents' },
        _react2.default.createElement(
          _reactHelmet2.default,
          null,
          _react2.default.createElement(
            'title',
            null,
            title
          )
        ),
        icons && icons(),
        _react2.default.createElement(_Navigation.Navigation, { items: menuItems }),
        _react2.default.createElement(
          'main',
          { className: 'department-main' },
          children
        ),
        _react2.default.createElement(_Modals.Modals, null)
      );
    }
  }]);

  return Layout;
}(_react.Component);

Layout.propTypes = {
  children: _propTypes2.default.node.isRequired,
  data: _propTypes2.default.object.isRequired,
  icons: _propTypes2.default.func,
  location: _propTypes2.default.object.isRequired,
  menuItems: _propTypes2.default.array.isRequired,
  title: _propTypes2.default.string
};

Layout.defaultProps = {
  title: 'Department'
};

exports.default = (0, _reactApollo.graphql)(_Auth.currentUserQuery, {
  options: function options(props) {
    return {
      variables: {
        token: _jsCookie2.default.get('token') || ''
      },
      fetchPolicy: 'network-only',
      pollInterval: props.updateUserInterval || 300000
    };
  }
})(Layout);