'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactApollo = require('react-apollo');

var _store = require('../../../modules/store');

var _Auth = require('../../Auth');

var _Notifications = require('../../../components/Notifications');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LayoutRoot = function LayoutRoot(_ref) {
  var children = _ref.children,
      graphQLUrl = _ref.graphQLUrl,
      initialState = _ref.initialState,
      middleware = _ref.middleware,
      reducers = _ref.reducers;

  var networkInterface = (0, _reactApollo.createBatchingNetworkInterface)({ uri: graphQLUrl, batchInterval: 10 });
  var apolloClient = new _reactApollo.ApolloClient({ networkInterface: networkInterface });
  var store = (0, _store.configureStore)(apolloClient, reducers, initialState, middleware);

  networkInterface.use([_Auth.authBatchMiddleware]);

  return _react2.default.createElement(
    _reactApollo.ApolloProvider,
    { store: store, client: apolloClient },
    _react2.default.createElement(
      'section',
      { className: 'department' },
      children,
      _react2.default.createElement(_Notifications.Notifications, null)
    )
  );
};

LayoutRoot.propTypes = {
  children: _propTypes2.default.node.isRequired,
  graphQLUrl: _propTypes2.default.string.isRequired,
  initialState: _propTypes2.default.object,
  middleware: _propTypes2.default.array,
  reducers: _propTypes2.default.object
};

exports.default = LayoutRoot;